#Vector Autoregression
#front matter
rm(list=ls())
library(vars)

#load the data
Mood <- read.csv("C:/.../HW2_S21.csv")
Data <- Mood[,3:5]

#run a VAR model
var.model <-VAR(Data, p=2, type="const"); var.model

#allow the BIC to choose the best lag length
var.model2 <-VAR(Data, p=2, lag.max=10, ic="SC", type="const")

#Assess the model
plot(var.model2)

#test for serial correlation
serial.test(var.model2, lags.pt = 16, type = "PT.adjusted")

#Does employment have a Granger causal effect?
causality(var.model, cause="mood")
causality(var.model, cause="expectations")
causality(var.model, cause="inflation")

#What's the impulse response if we perturb employment?
var.model.irf <- irf(var.model, impulse = "inflation", response = c("mood", "expectations", "inflation"), boot =
                       FALSE)

#Impulse response analysis
plot(var.model.irf)



#Error-Correction Model
rm(list=ls())
library(timeSeries)
library(tseries)

#load data and create lags
Data <- read.csv("C:/Users/jch61/Desktop/My_Time_Series/HW2/HW2_S14.csv")

mood<-ts(Data[,3])
expectations<-ts(Data[,4])
inflation<-ts(Data[,5])
l.mood<-lag(mood,-1)
d.mood<-diff(mood)
l.expectations<-lag(expectations,-1)
d.expectations<-diff(expectations)
l.inflation<-lag(inflation,-1)
d.inflation<-diff(inflation)

#Integrated?
adf.test(mood) #Fail to reject at .05 (Reject at .10)
adf.test(expectations) #Fail to reject
adf.test(inflation)


#Step One of the Engle-Granger Two-Step estimation
equilibrium<-lm(mood~expectations+inflation)
z<-ts(equilibrium$residuals)
l.z<-lag(z,-1)

#Are the series cointegrated?
adf.test(z) #Reject at .10; Not ideal.

#Load lags and differences into a single data frame
data_combined<-ts.union(mood,l.mood,d.mood,expectations,l.expectations,d.expectations,l.inflation,d.inflation,z,l.z,dframe=TRUE)

#Step Two of the Engle-Granger Two-Step estimation
two.step_mood<-lm(d.mood~d.expectations+d.inflation+l.z,data=data_combined)
sum_mood = summary(two.step_mood); sum_mood
two.step_exp<-lm(d.expectations~d.mood+d.inflation+l.z,data=data_combined)
sum_exp = summary(two.step_exp); sum_exp
two.step_exp<-lm(d.inflation~d.mood+d.expectations+l.z,data=data_combined)
sum_exp = summary(two.step_exp); sum_exp




